function $AdfDhtmlRichDialogService$$() {
  this.Init();
}
$goog$exportSymbol$$("AdfDhtmlRichDialogService", $AdfDhtmlRichDialogService$$);
$goog$exportSymbol$$("AdfDhtmlRichDialogService", $AdfDhtmlRichDialogService$$);
$AdfDhtmlRichDialogService$$.$_PANELWINDOWID_EXPANDO$ = "data-afr-panelwindowid";
$AdfDhtmlRichDialogService$$.$_INLINEFRAMEID_EXPANDO$ = "data-afr-inlineframeid";
$AdfDhtmlRichDialogService$$.$_RTNID_EXPANDO$ = "data-afr-rtnid";
$AdfObject$$.$createSubclass$($AdfDhtmlRichDialogService$$);
$AdfDhtmlRichDialogService$$.$getInstance$ = function $$AdfDhtmlRichDialogService$$$$getInstance$$() {
  null == this.$_theInstance$ && (this.$_theInstance$ = new $AdfDhtmlRichDialogService$$);
  return this.$_theInstance$;
};
$AdfDhtmlRichDialogService$$.getInstance = $AdfDhtmlRichDialogService$$.$getInstance$;
$goog$exportSymbol$$("AdfDhtmlRichDialogService.getInstance", $AdfDhtmlRichDialogService$$.$getInstance$);
$AdfDhtmlRichDialogService$$.$dialogExists$ = function $$AdfDhtmlRichDialogService$$$$dialogExists$$($rtnId$$5$$) {
  return $AdfDhtmlRichDialogService$$.$_getDialogStateToken$($rtnId$$5$$) ? !0 : !1;
};
$AdfDhtmlRichDialogService$$.dialogExists = $AdfDhtmlRichDialogService$$.$dialogExists$;
$goog$exportSymbol$$("AdfDhtmlRichDialogService.dialogExists", $AdfDhtmlRichDialogService$$.$dialogExists$);
$AdfDhtmlRichDialogService$$.prototype.$launchWindow$ = function $$AdfDhtmlRichDialogService$$$$$launchWindow$$($srcURL$$, $windowName$$2$$, $features$$2$$, $dialogSourceClientId_state$$70$$) {
  $AdfAssert$$.$assertString$($srcURL$$);
  $AdfAssert$$.$assertString$($windowName$$2$$);
  $AdfAssert$$.$assertObject$($features$$2$$);
  $AdfAssert$$.$assertStringOrNull$($dialogSourceClientId_state$$70$$);
  var $page$$188$$ = $AdfPage$$.$PAGE$;
  try {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!0, "LAUNCHING_WINDOW_DIALOG");
    var $rtnId$$6$$ = $AdfDhtmlRichDialogService$$.$_generateRtnId$(), $launchSourceId$$13$$ = $AdfDhtmlRichDialogService$$.$_normalizeLaunchSourceId$($dialogSourceClientId_state$$70$$), $modal$$3$$ = $features$$2$$.$windowModalityType$ && $features$$2$$.$windowModalityType$ == $AdfDhtmlRichDialogService$$.$_WINDOW_MODALITY_TYPE_APPLICATION_MODAL$ ? !0 : !1;
    $dialogSourceClientId_state$$70$$ = {launchSourceId:$launchSourceId$$13$$, modal:$modal$$3$$, windowName:$windowName$$2$$, rtnId:$rtnId$$6$$};
    $AdfDhtmlRichDialogService$$.$_setDialogStateToken$($rtnId$$6$$, $dialogSourceClientId_state$$70$$);
    $modal$$3$$ && $AdfDhtmlRichDialogService$$.$_showModalGlass$();
    var $childWindow$$1$$ = $AdfDhtmlRichDialogService$$.$_openWindow$($srcURL$$, $windowName$$2$$, $features$$2$$, $rtnId$$6$$);
    $dialogSourceClientId_state$$70$$.childWindow = $childWindow$$1$$;
    $AdfDhtmlRichDialogService$$.$_setDialogStateToken$($rtnId$$6$$, $dialogSourceClientId_state$$70$$);
    $page$$188$$.$scheduleTimer$($page$$188$$, $AdfDhtmlRichDialogService$$.$_setWindowFocus$, $rtnId$$6$$, 100, {isSynchronized:!0});
  } finally {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!1);
  }
};
$AdfDhtmlRichDialogService$$.prototype.launchWindow = $AdfDhtmlRichDialogService$$.prototype.$launchWindow$;
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlRichDialogService.prototype.launchWindow", {$launchWindow$:$AdfDhtmlRichDialogService$$.prototype.$launchWindow$});
$AdfDhtmlRichDialogService$$.prototype.$launchInline$ = function $$AdfDhtmlRichDialogService$$$$$launchInline$$($hints$$100_popupId$$68$$) {
  $AdfAssert$$.$assertString$($hints$$100_popupId$$68$$);
  var $page$$189$$ = $AdfPage$$.$PAGE$;
  try {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!0, "LAUNCHING_INLINE_DIALOG");
    var $popup$$39$$ = $page$$189$$.$findComponent$($hints$$100_popupId$$68$$);
    $AdfAssert$$.$assertPrototype$($popup$$39$$, AdfRichPopup);
    $popup$$39$$.addEventListener($AdfPopupOpenedEvent$$.$POPUP_OPENED_EVENT_TYPE$, $AdfDhtmlRichDialogService$$.$_popupOpenedHandler$);
    $popup$$39$$.addEventListener($AdfPopupClosedEvent$$.$POPUP_CLOSED_EVENT_TYPE$, $AdfDhtmlRichDialogService$$.$_popupClosedHandler$);
    $popup$$39$$.$getPeer$().bind($popup$$39$$);
    var $rtnId$$7$$ = $popup$$39$$.$getProperty$("_rtnId"), $dialogSourceClientId$$1$$ = $popup$$39$$.$getProperty$("_launchId"), $inlineFrameId$$ = $popup$$39$$.$getProperty$("_inlineFrameId"), $isCancellationDisabled$$ = $popup$$39$$.$getProperty$("_isCancellationDisabled"), $launchSourceId$$14$$ = $AdfDhtmlRichDialogService$$.$_normalizeLaunchSourceId$($dialogSourceClientId$$1$$), $state$$71$$ = {launchSourceId:$launchSourceId$$14$$, popupId:$hints$$100_popupId$$68$$, frameName:$inlineFrameId$$, 
    rtnId:$rtnId$$7$$, panelWindowId:$popup$$39$$.$getProperty$("_panelWindowId")};
    $AdfDhtmlRichDialogService$$.$_setDialogStateToken$($rtnId$$7$$, $state$$71$$);
    $hints$$100_popupId$$68$$ = {};
    $launchSourceId$$14$$ && ($hints$$100_popupId$$68$$[AdfRichPopup.$HINT_LAUNCH_ID$] = $launchSourceId$$14$$);
    $isCancellationDisabled$$ && ($hints$$100_popupId$$68$$.closeOnEscape = !1);
    $popup$$39$$.show($hints$$100_popupId$$68$$);
  } finally {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!1);
  }
};
$AdfDhtmlRichDialogService$$.prototype.launchInline = $AdfDhtmlRichDialogService$$.prototype.$launchInline$;
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlRichDialogService.prototype.launchInline", {$launchInline$:$AdfDhtmlRichDialogService$$.prototype.$launchInline$});
$AdfDhtmlRichDialogService$$.prototype.$returnFrom$ = function $$AdfDhtmlRichDialogService$$$$$returnFrom$$($rtnId$$8$$) {
  var $state$$72$$ = $AdfDhtmlRichDialogService$$.$_getDialogStateToken$($rtnId$$8$$);
  if ($state$$72$$) {
    try {
      if ($state$$72$$.popupId) {
        $AdfDhtmlRichDialogService$$.$_setBusy$(!0, "CLOSING_INLINE_DIALOG"), $AdfDhtmlRichDialogService$$.$_hidePopup$($state$$72$$), $AdfDhtmlRichDialogService$$.$_queueReturnEvent$($state$$72$$);
      } else {
        $AdfDhtmlRichDialogService$$.$_setBusy$(!0, "CLOSING_WINDOW_DIALOG");
        if (!$AdfDhtmlRichDialogService$$.$_closeWindow$($state$$72$$)) {
          $state$$72$$.isReturnFromPending = !0;
          return;
        }
        $AdfDhtmlRichDialogService$$.$_queueReturnEvent$($state$$72$$);
        $state$$72$$.modal && $AdfDhtmlRichDialogService$$.$_hideModalGlass$();
      }
      $AdfDhtmlRichDialogService$$.$_removeDialogStateToken$($rtnId$$8$$);
    } finally {
      $AdfDhtmlRichDialogService$$.$_setBusy$(!1);
    }
  } else {
    $AdfLogger$$.$LOGGER$.warning("dialog state missing or already returned for rtnId:", $rtnId$$8$$);
  }
};
$AdfDhtmlRichDialogService$$.prototype.returnFrom = $AdfDhtmlRichDialogService$$.prototype.$returnFrom$;
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlRichDialogService.prototype.returnFrom", {$returnFrom$:$AdfDhtmlRichDialogService$$.prototype.$returnFrom$});
$AdfDhtmlRichDialogService$$.prototype.$checkForWindowCanceled$ = function $$AdfDhtmlRichDialogService$$$$$checkForWindowCanceled$$($rtnId$$9$$) {
  $AdfAssert$$.$assertNumeric$($rtnId$$9$$);
  var $state$$73$$ = $AdfDhtmlRichDialogService$$.$_getDialogStateToken$($rtnId$$9$$);
  if ($state$$73$$) {
    void 0 === $state$$73$$.loadingState && ($state$$73$$.loadingState = "unloading");
    try {
      if ($AdfDhtmlRichDialogService$$.$_setBusy$(!0, "CLOSING_WINDOW_DIALOG"), $state$$73$$.childWindow.closed) {
        $state$$73$$.modal && $AdfDhtmlRichDialogService$$.$_hideModalGlass$(), $state$$73$$.isReturnFromPending ? $AdfDhtmlRichDialogService$$.$_queueReturnEvent$($state$$73$$) : $AdfDhtmlRichDialogService$$.$_notifyWindowClosed$($rtnId$$9$$), $AdfDhtmlRichDialogService$$.$_removeDialogStateToken$($rtnId$$9$$);
      } else {
        if ("unloading" === $state$$73$$.loadingState) {
          var $page$$190$$ = $AdfPage$$.$PAGE$;
          $page$$190$$.$scheduleTimer$($page$$190$$, $AdfDhtmlRichDialogService$$.$getInstance$().$checkForWindowCanceled$, $rtnId$$9$$, 100, {isSynchronized:!0});
        } else {
          $state$$73$$.loadingState = void 0;
        }
      }
    } finally {
      $AdfDhtmlRichDialogService$$.$_setBusy$(!1);
    }
  }
};
$AdfDhtmlRichDialogService$$.prototype.checkForWindowCanceled = $AdfDhtmlRichDialogService$$.prototype.$checkForWindowCanceled$;
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlRichDialogService.prototype.checkForWindowCanceled", {$checkForWindowCanceled$:$AdfDhtmlRichDialogService$$.prototype.$checkForWindowCanceled$});
$AdfDhtmlRichDialogService$$.prototype.$unsetWindowDialogCanceled$ = function $$AdfDhtmlRichDialogService$$$$$unsetWindowDialogCanceled$$($rtnId$$10_state$$74$$) {
  $AdfAssert$$.$assertNumeric$($rtnId$$10_state$$74$$);
  ($rtnId$$10_state$$74$$ = $AdfDhtmlRichDialogService$$.$_getDialogStateToken$($rtnId$$10_state$$74$$)) && "unloading" === $rtnId$$10_state$$74$$.loadingState && ($rtnId$$10_state$$74$$.loadingState = "loading");
};
$AdfDhtmlRichDialogService$$.prototype.unsetWindowDialogCanceled = $AdfDhtmlRichDialogService$$.prototype.$unsetWindowDialogCanceled$;
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlRichDialogService.prototype.unsetWindowDialogCanceled", {$unsetWindowDialogCanceled$:$AdfDhtmlRichDialogService$$.prototype.$unsetWindowDialogCanceled$});
$AdfDhtmlRichDialogService$$.$_setBusy$ = function $$AdfDhtmlRichDialogService$$$$_setBusy$$($isBusy$$22$$, $op$$1$$) {
  var $instance$$31$$ = $AdfDhtmlRichDialogService$$.$getInstance$();
  $instance$$31$$.$Busy$ = $isBusy$$22$$;
  $instance$$31$$.$_trackBusyState$ && $instance$$31$$.$_trackBusyState$($isBusy$$22$$, $op$$1$$);
};
$AdfDhtmlRichDialogService$$.$isBusy$ = function $$AdfDhtmlRichDialogService$$$$isBusy$$() {
  var $instance$$32$$ = $AdfDhtmlRichDialogService$$.$getInstance$();
  if ($instance$$32$$.$Busy$) {
    return !0;
  }
  var $stateMap$$2$$ = $instance$$32$$.$StateMap$;
  if ($stateMap$$2$$) {
    for (rtnId in $stateMap$$2$$) {
      var $state$$75$$ = $stateMap$$2$$[rtnId];
      if ($state$$75$$ && $state$$75$$.isReturnFromPending) {
        return !0;
      }
    }
  }
  return $instance$$32$$.$_isBusyForAutomation$ && $instance$$32$$.$_isBusyForAutomation$() ? !0 : !1;
};
$goog$exportSymbol$$("AdfDhtmlRichDialogService.isBusy", $AdfDhtmlRichDialogService$$.$isBusy$);
$AdfDhtmlRichDialogService$$.prototype.$cancelAll$ = function $$AdfDhtmlRichDialogService$$$$$cancelAll$$() {
  try {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!0);
    var $stateMap$$3$$ = $AdfDhtmlRichDialogService$$.$getInstance$().$StateMap$;
    if ($stateMap$$3$$) {
      for (rtnId in $stateMap$$3$$) {
        $AdfDhtmlRichDialogService$$.$_cancel$();
      }
    }
  } finally {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!1);
  }
};
$AdfDhtmlRichDialogService$$.prototype.cancelAll = $AdfDhtmlRichDialogService$$.prototype.$cancelAll$;
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlRichDialogService.prototype.cancelAll", {$cancelAll$:$AdfDhtmlRichDialogService$$.prototype.$cancelAll$});
$AdfDhtmlRichDialogService$$.prototype.$__visitWindows$ = function $$AdfDhtmlRichDialogService$$$$$__visitWindows$$($callback$$119$$) {
  var $stateMap$$4$$ = $AdfDhtmlRichDialogService$$.$getInstance$().$StateMap$;
  if ($stateMap$$4$$) {
    for (rtnId in $stateMap$$4$$) {
      var $state$$76$$ = $stateMap$$4$$[rtnId];
      $state$$76$$ && $callback$$119$$($state$$76$$);
    }
  }
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDhtmlRichDialogService.prototype.__visitWindows", {$__visitWindows$:$AdfDhtmlRichDialogService$$.prototype.$__visitWindows$});
$AdfDhtmlRichDialogService$$.$_setWindowFocus$ = function $$AdfDhtmlRichDialogService$$$$_setWindowFocus$$($rtnId$$11_state$$77$$) {
  $AdfAssert$$.$assertNumeric$($rtnId$$11_state$$77$$);
  if ($rtnId$$11_state$$77$$ = $AdfDhtmlRichDialogService$$.$_getDialogStateToken$($rtnId$$11_state$$77$$)) {
    childWindow = $rtnId$$11_state$$77$$.childWindow, childWindow.focus();
  }
};
$AdfDhtmlRichDialogService$$.$_cancel$ = function $$AdfDhtmlRichDialogService$$$$_cancel$$() {
  var $rtnId$$12$$ = rtnId;
  $AdfAssert$$.$assertNumeric$($rtnId$$12$$);
  var $state$$78$$ = $AdfDhtmlRichDialogService$$.$_getDialogStateToken$($rtnId$$12$$);
  $state$$78$$ && ($state$$78$$.popupId ? $AdfDhtmlRichDialogService$$.$_cancelPopup$($state$$78$$) : ($AdfDhtmlRichDialogService$$.$_closeWindow$($state$$78$$), $state$$78$$.modal && $AdfDhtmlRichDialogService$$.$_hideModalGlass$()), $AdfDhtmlRichDialogService$$.$_removeDialogStateToken$($rtnId$$12$$), $AdfDhtmlRichDialogService$$.$_notifyWindowClosed$($rtnId$$12$$));
};
$AdfDhtmlRichDialogService$$.$_queueReturnEvent$ = function $$AdfDhtmlRichDialogService$$$$_queueReturnEvent$$($launchSourceId$$15_state$$79_targetComponent$$8$$) {
  $AdfAssert$$.$assertObject$($launchSourceId$$15_state$$79_targetComponent$$8$$);
  var $rtnId$$13$$ = $launchSourceId$$15_state$$79_targetComponent$$8$$.rtnId;
  ($launchSourceId$$15_state$$79_targetComponent$$8$$ = $launchSourceId$$15_state$$79_targetComponent$$8$$.launchSourceId) ? ($launchSourceId$$15_state$$79_targetComponent$$8$$ = $AdfPage$$.$PAGE$.$findComponent$($launchSourceId$$15_state$$79_targetComponent$$8$$)) ? ($AdfDhtmlRichDialogService$$.$_notifyWindowClosed$($rtnId$$13$$, !0), (new $AdfReturnEvent$$($launchSourceId$$15_state$$79_targetComponent$$8$$)).$queue$(), $launchSourceId$$15_state$$79_targetComponent$$8$$.focus()) : $AdfDhtmlRichDialogService$$.$_notifyWindowClosed$($rtnId$$13$$) : 
  $AdfDhtmlRichDialogService$$.$_notifyWindowClosed$($rtnId$$13$$);
};
$AdfDhtmlRichDialogService$$.$_normalizeLaunchSourceId$ = function $$AdfDhtmlRichDialogService$$$$_normalizeLaunchSourceId$$($dialogSourceClientId$$2$$) {
  if (!$dialogSourceClientId$$2$$ || 0 == $dialogSourceClientId$$2$$.length) {
    return null;
  }
  var $page$$191$$ = $AdfPage$$.$PAGE$;
  if (!$page$$191$$.$findComponent$($dialogSourceClientId$$2$$)) {
    var $lastSeperator_returnId$$2$$ = $dialogSourceClientId$$2$$.lastIndexOf(":");
    if (-1 != $lastSeperator_returnId$$2$$) {
      var $idBeforeCurrency_secondToLastSeperator$$ = $dialogSourceClientId$$2$$.lastIndexOf(":", $lastSeperator_returnId$$2$$ - 1);
      if (-1 != $idBeforeCurrency_secondToLastSeperator$$) {
        var $idBeforeCurrency_secondToLastSeperator$$ = $dialogSourceClientId$$2$$.substring(0, $idBeforeCurrency_secondToLastSeperator$$), $parentCollection$$ = $page$$191$$.$findComponent$($idBeforeCurrency_secondToLastSeperator$$);
        if ($parentCollection$$ && window.AdfUICollection && $parentCollection$$ instanceof AdfUICollection && ($lastSeperator_returnId$$2$$ = $idBeforeCurrency_secondToLastSeperator$$.concat($dialogSourceClientId$$2$$.substring($lastSeperator_returnId$$2$$)), $page$$191$$.$findComponent$($lastSeperator_returnId$$2$$))) {
          return $lastSeperator_returnId$$2$$;
        }
      }
    }
  }
  return $dialogSourceClientId$$2$$;
};
$AdfDhtmlRichDialogService$$.$_generateRtnId$ = function $$AdfDhtmlRichDialogService$$$$_generateRtnId$$() {
  return (new Date).getTime();
};
$AdfDhtmlRichDialogService$$.$_closeWindow$ = function $$AdfDhtmlRichDialogService$$$$_closeWindow$$($childWindow$$3_state$$80$$) {
  $AdfAssert$$.$assertObject$($childWindow$$3_state$$80$$);
  $childWindow$$3_state$$80$$ = $childWindow$$3_state$$80$$.childWindow;
  $childWindow$$3_state$$80$$.close();
  return $childWindow$$3_state$$80$$.closed;
};
$AdfDhtmlRichDialogService$$.$_hidePopup$ = function $$AdfDhtmlRichDialogService$$$$_hidePopup$$($popup$$40_popupId$$69_state$$81$$) {
  $popup$$40_popupId$$69_state$$81$$ = $popup$$40_popupId$$69_state$$81$$.popupId;
  $AdfAssert$$.$assertString$($popup$$40_popupId$$69_state$$81$$);
  $popup$$40_popupId$$69_state$$81$$ = $AdfPage$$.$PAGE$.$findComponent$($popup$$40_popupId$$69_state$$81$$);
  $AdfAssert$$.$assertPrototype$($popup$$40_popupId$$69_state$$81$$, AdfRichPopup);
  $popup$$40_popupId$$69_state$$81$$ && ($AdfDhtmlRichDialogService$$.$__unloadDocument$($popup$$40_popupId$$69_state$$81$$), $popup$$40_popupId$$69_state$$81$$.$hide$());
};
$AdfDhtmlRichDialogService$$.$_cancelPopup$ = function $$AdfDhtmlRichDialogService$$$$_cancelPopup$$($popup$$41_popupId$$70_state$$82$$) {
  $popup$$41_popupId$$70_state$$82$$ = $popup$$41_popupId$$70_state$$82$$.popupId;
  $AdfAssert$$.$assertString$($popup$$41_popupId$$70_state$$82$$);
  $popup$$41_popupId$$70_state$$82$$ = $AdfPage$$.$PAGE$.$findComponent$($popup$$41_popupId$$70_state$$82$$);
  $AdfAssert$$.$assertPrototype$($popup$$41_popupId$$70_state$$82$$, AdfRichPopup);
  $popup$$41_popupId$$70_state$$82$$ && ($AdfDhtmlRichDialogService$$.$__unloadDocument$($popup$$41_popupId$$70_state$$82$$), $popup$$41_popupId$$70_state$$82$$.cancel());
};
$AdfDhtmlRichDialogService$$.$__unloadDocument$ = function $$AdfDhtmlRichDialogService$$$$__unloadDocument$$($inlineFrameId$$1_inlineFramePeer_popup$$42$$) {
  $AdfAssert$$.$assertPrototype$($inlineFrameId$$1_inlineFramePeer_popup$$42$$, AdfRichPopup);
  var $frameDom$$2_inlineFrame$$80_page$$192$$ = $AdfPage$$.$PAGE$;
  $inlineFrameId$$1_inlineFramePeer_popup$$42$$ = $inlineFrameId$$1_inlineFramePeer_popup$$42$$.$getProperty$("_inlineFrameId");
  $frameDom$$2_inlineFrame$$80_page$$192$$ = $frameDom$$2_inlineFrame$$80_page$$192$$.$findComponent$($inlineFrameId$$1_inlineFramePeer_popup$$42$$);
  $inlineFrameId$$1_inlineFramePeer_popup$$42$$ = $frameDom$$2_inlineFrame$$80_page$$192$$.$getPeer$();
  $inlineFrameId$$1_inlineFramePeer_popup$$42$$.bind($frameDom$$2_inlineFrame$$80_page$$192$$);
  $frameDom$$2_inlineFrame$$80_page$$192$$ = $inlineFrameId$$1_inlineFramePeer_popup$$42$$.$__getIframe$();
  $AdfAssert$$.$assertDomElement$($frameDom$$2_inlineFrame$$80_page$$192$$, "IFRAME");
  $frameDom$$2_inlineFrame$$80_page$$192$$.setAttribute("src", "about:blank");
};
$AdfDhtmlRichDialogService$$.$_getOpenDialogCount$ = function $$AdfDhtmlRichDialogService$$$$_getOpenDialogCount$$() {
  var $n$$19$$ = 0, $stateMap$$5$$ = $AdfDhtmlRichDialogService$$.$getInstance$().$StateMap$;
  if ($stateMap$$5$$) {
    for (rtnId in $stateMap$$5$$) {
      $n$$19$$++;
    }
  }
  return $n$$19$$;
};
$AdfDhtmlRichDialogService$$.$_setDialogStateToken$ = function $$AdfDhtmlRichDialogService$$$$_setDialogStateToken$$($rtnId$$14$$, $state$$83$$) {
  var $key$$87$$ = "" + $rtnId$$14$$, $stateMap$$6$$ = $AdfDhtmlRichDialogService$$.$getInstance$().$StateMap$;
  $stateMap$$6$$ || ($stateMap$$6$$ = {}, $AdfDhtmlRichDialogService$$.$getInstance$().$StateMap$ = $stateMap$$6$$);
  $stateMap$$6$$[$key$$87$$] = $state$$83$$;
  $AdfDhtmlRichDialogService$$.$getInstance$().$dlgInfo$ = $state$$83$$;
};
$AdfDhtmlRichDialogService$$.$_getDialogStateToken$ = function $$AdfDhtmlRichDialogService$$$$_getDialogStateToken$$($rtnId$$15$$) {
  var $stateMap$$7$$ = $AdfDhtmlRichDialogService$$.$getInstance$().$StateMap$;
  return $stateMap$$7$$ ? $stateMap$$7$$["" + $rtnId$$15$$] : null;
};
$AdfDhtmlRichDialogService$$.$_removeDialogStateToken$ = function $$AdfDhtmlRichDialogService$$$$_removeDialogStateToken$$($key$$89_rtnId$$16$$) {
  var $stateMap$$8$$ = $AdfDhtmlRichDialogService$$.$getInstance$().$StateMap$;
  $stateMap$$8$$ && ($key$$89_rtnId$$16$$ = "" + $key$$89_rtnId$$16$$, $AdfDhtmlRichDialogService$$.$getInstance$().$dlgInfo$ = $stateMap$$8$$[$key$$89_rtnId$$16$$], delete $stateMap$$8$$[$key$$89_rtnId$$16$$]);
};
$AdfDhtmlRichDialogService$$.$_openWindow$ = function $$AdfDhtmlRichDialogService$$$$_openWindow$$($srcURL$$1_targetURL$$, $childWindow$$4_windowName$$3$$, $featureString_features$$3$$, $rtnId$$17$$) {
  var $domWindow$$123$$ = $AdfPage$$.$PAGE$.$getDomWindow$();
  $AdfCollections$$.$union$($AdfDhtmlRichDialogService$$.$_WINDOW_DEFAULT_FEATURES_MAP$, $featureString_features$$3$$, $featureString_features$$3$$);
  $featureString_features$$3$$ = $AdfDhtmlRichDialogService$$.$_buildFeatureString$($featureString_features$$3$$);
  $srcURL$$1_targetURL$$ = $AdfDhtmlRichDialogService$$.$_encodeURL$($srcURL$$1_targetURL$$, $rtnId$$17$$);
  $childWindow$$4_windowName$$3$$ = $domWindow$$123$$.open($srcURL$$1_targetURL$$, $childWindow$$4_windowName$$3$$, $featureString_features$$3$$);
  try {
    $childWindow$$4_windowName$$3$$.opener = $domWindow$$123$$;
  } catch ($e$$150$$) {
    $AdfLogger$$.$LOGGER$.$logErrorAsWarning$($e$$150$$, " error setting opener of child window.");
  }
  return $childWindow$$4_windowName$$3$$;
};
$AdfDhtmlRichDialogService$$.$_buildFeatureString$ = function $$AdfDhtmlRichDialogService$$$$_buildFeatureString$$($features$$4$$) {
  var $featureString$$1$$ = "", $k$$11$$;
  for ($k$$11$$ in $features$$4$$) {
    0 < $featureString$$1$$.length && ($featureString$$1$$ += ","), $featureString$$1$$ += $k$$11$$ + "\x3d" + $features$$4$$[$k$$11$$];
  }
  return $featureString$$1$$;
};
$AdfDhtmlRichDialogService$$.$_encodeURL$ = function $$AdfDhtmlRichDialogService$$$$_encodeURL$$($srcURL$$2$$, $rtnId$$18$$) {
  $AdfAssert$$.$assertString$($srcURL$$2$$);
  $AdfAssert$$.$assertNumeric$($rtnId$$18$$);
  return $srcURL$$2$$ + "\x26_rtrnId\x3d" + $rtnId$$18$$;
};
$AdfDhtmlRichDialogService$$.$_showModalGlass$ = function $$AdfDhtmlRichDialogService$$$$_showModalGlass$$() {
  var $dummyLayer_page$$194$$ = $AdfPage$$.$PAGE$, $modalityManager$$4$$ = $dummyLayer_page$$194$$.$getModalityManager$(), $zorderManager$$1$$ = $dummyLayer_page$$194$$.$getZOrderManager$(), $dummyLayer_page$$194$$ = $dummyLayer_page$$194$$.$getDomDocument$().createElement("div");
  $zorderManager$$1$$.$addElementToLayer$($dummyLayer_page$$194$$, $AdfDhtmlZOrderManager$$.$FLOATINGTYPE_WINDOW$);
  $modalityManager$$4$$.$pushModal$($dummyLayer_page$$194$$);
  $zorderManager$$1$$.$removeElement$($dummyLayer_page$$194$$);
};
$AdfDhtmlRichDialogService$$.$_hideModalGlass$ = function $$AdfDhtmlRichDialogService$$$$_hideModalGlass$$() {
  $AdfPage$$.$PAGE$.$getModalityManager$().$popModal$();
};
$AdfDhtmlRichDialogService$$.$hasModalDialogsOpen$ = function $$AdfDhtmlRichDialogService$$$$hasModalDialogsOpen$$() {
  var $stateMap$$9$$ = $AdfDhtmlRichDialogService$$.$getInstance$().$StateMap$;
  if ($stateMap$$9$$) {
    var $page$$195$$ = $AdfPage$$.$PAGE$;
    for (rtnId in $stateMap$$9$$) {
      var $panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$ = $stateMap$$9$$[rtnId];
      if ($panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$ && $panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$.modal || $panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$.popupId && ($panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$ = $page$$195$$.$findComponent$($panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$.popupId), $panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$.$getPeer$().bind($panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$), $panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$ = 
      $panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$.$getProperty$("_panelWindowId"), $AdfAssert$$.$assertString$($panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$), $panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$ = $page$$195$$.$findComponent$($panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$), $AdfAssert$$.$assertPrototype$($panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$, AdfRichPanelWindow), $panelWindow$$1_panelWindowId$$1_popup$$43_state$$84$$.getModal())) {
        return !0;
      }
    }
  }
  return !1;
};
$goog$exportSymbol$$("AdfDhtmlRichDialogService.hasModalDialogsOpen", $AdfDhtmlRichDialogService$$.$hasModalDialogsOpen$);
$AdfDhtmlRichDialogService$$.$_popupOpenedHandler$ = function $$AdfDhtmlRichDialogService$$$$_popupOpenedHandler$$($event$$279$$) {
  try {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!0);
    var $agent$$558$$ = $AdfAgent$$.$AGENT$, $page$$196$$ = $AdfPage$$.$PAGE$, $popup$$44$$ = $event$$279$$.getSource(), $popupPeer$$5$$ = $popup$$44$$.$getPeer$();
    $popupPeer$$5$$.bind($popup$$44$$);
    var $popupDom$$3$$ = $popupPeer$$5$$.$getDomElement$(), $panelWindowId$$2$$ = $popup$$44$$.$getProperty$("_panelWindowId"), $inlineFrameId$$2$$ = $popup$$44$$.$getProperty$("_inlineFrameId"), $inlineFrame$$81$$ = $page$$196$$.$findComponent$($inlineFrameId$$2$$), $inlineFramePeer$$1$$ = $inlineFrame$$81$$.$getPeer$();
    $inlineFramePeer$$1$$.bind($inlineFrame$$81$$);
    var $frameDom$$3$$ = $inlineFramePeer$$1$$.$__getIframe$();
    $AdfAssert$$.$assertDomElement$($frameDom$$3$$, "IFRAME");
    var $rtnId$$19$$ = $popup$$44$$.$getProperty$("_rtnId");
    $frameDom$$3$$.setAttribute($AdfDhtmlRichDialogService$$.$_PANELWINDOWID_EXPANDO$, $panelWindowId$$2$$);
    $popupDom$$3$$.setAttribute($AdfDhtmlRichDialogService$$.$_INLINEFRAMEID_EXPANDO$, $inlineFrameId$$2$$);
    $frameDom$$3$$.setAttribute($AdfDhtmlRichDialogService$$.$_RTNID_EXPANDO$, $rtnId$$19$$);
    $agent$$558$$.$addBubbleEventListener$($frameDom$$3$$, "load", $AdfDhtmlRichDialogService$$.$_iframeLoadHandler$);
    $page$$196$$.$findComponent$($panelWindowId$$2$$).$getProperty$("closeIconVisible") || $inlineFrame$$81$$.addEventListener($AdfComponentEvent$$.$BLUR_EVENT_TYPE$, $AdfDhtmlRichDialogService$$.$_iframeBlurHandler$, this);
    var $dialogURL$$ = $popup$$44$$.$getProperty$("_dialogURL");
    $frameDom$$3$$.src = $dialogURL$$;
    $page$$196$$.$isPPRNavigationEnabled$() && $AdfDhtmlRichDialogService$$.$_checkForIframeTitleChangeWithPPRNavOn$($rtnId$$19$$);
  } finally {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!1);
  }
};
$AdfDhtmlRichDialogService$$.$_iframeBlurHandler$ = function $$AdfDhtmlRichDialogService$$$$_iframeBlurHandler$$($event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$) {
  var $inlineFramePeer$$2_nativeEvent$$54_popupPeer$$6$$ = $event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$.$getNativeEvent$();
  $AdfAgent$$.$AGENT$.preventDefault($inlineFramePeer$$2_nativeEvent$$54_popupPeer$$6$$);
  $event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$ = $event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$.getSource();
  $inlineFramePeer$$2_nativeEvent$$54_popupPeer$$6$$ = $event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$.$getPeer$();
  $inlineFramePeer$$2_nativeEvent$$54_popupPeer$$6$$.bind($event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$);
  $event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$ = $inlineFramePeer$$2_nativeEvent$$54_popupPeer$$6$$.$__getIframe$().getAttribute($AdfDhtmlRichDialogService$$.$_PANELWINDOWID_EXPANDO$);
  $event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$ = $AdfPage$$.$PAGE$.$findComponent$($event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$).getParent();
  $inlineFramePeer$$2_nativeEvent$$54_popupPeer$$6$$ = $event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$.$getPeer$();
  $inlineFramePeer$$2_nativeEvent$$54_popupPeer$$6$$.bind($event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$);
  $inlineFramePeer$$2_nativeEvent$$54_popupPeer$$6$$.$getPopupWindow$($event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$, $event$$280_inlineFrame$$82_panelWindowId$$3_popup$$45$$.$getClientId$()).$handleActivate$(!0);
};
$AdfDhtmlRichDialogService$$.$_popupClosedHandler$ = function $$AdfDhtmlRichDialogService$$$$_popupClosedHandler$$($event$$281$$) {
  try {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!0, "CLOSING_INLINE_DIALOG");
    var $agent$$559$$ = $AdfAgent$$.$AGENT$, $popup$$46$$ = $event$$281$$.getSource(), $popupPeer$$7$$ = $popup$$46$$.$getPeer$();
    $popupPeer$$7$$.bind($popup$$46$$);
    var $inlineFrameId$$3$$ = $popupPeer$$7$$.$getDomElement$().getAttribute($AdfDhtmlRichDialogService$$.$_INLINEFRAMEID_EXPANDO$), $rtnId$$20$$ = $popup$$46$$.$getProperty$("_rtnId"), $inlineFrame$$83$$ = $AdfPage$$.$PAGE$.$findComponent$($inlineFrameId$$3$$);
    $AdfAssert$$.$assertPrototype$($inlineFrame$$83$$, AdfRichInlineFrame);
    var $inlineFramePeer$$3$$ = $inlineFrame$$83$$.$getPeer$();
    $inlineFramePeer$$3$$.bind($inlineFrame$$83$$);
    var $frameDom$$5$$ = $inlineFramePeer$$3$$.$__getIframe$();
    $AdfAssert$$.$assertDomElement$($frameDom$$5$$, "IFRAME");
    $frameDom$$5$$.setAttribute("src", "about:blank");
    $agent$$559$$.$removeBubbleEventListener$($frameDom$$5$$, "load", $AdfDhtmlRichDialogService$$.$_iframeLoadHandler$);
    $AdfDhtmlRichDialogService$$.$_removeDialogStateToken$($rtnId$$20$$);
    $AdfDhtmlRichDialogService$$.$_notifyWindowClosed$($rtnId$$20$$);
  } finally {
    $AdfDhtmlRichDialogService$$.$_setBusy$(!1);
  }
};
$AdfDhtmlRichDialogService$$.$_iframeLoadHandler$ = function $$AdfDhtmlRichDialogService$$$$_iframeLoadHandler$$($event$$282_panelWindowId$$4$$) {
  var $page$$197_panelWindow$$4$$ = $AdfPage$$.$PAGE$, $frameDom$$6_title$$17$$ = $AdfAgent$$.$AGENT$.$getEventTarget$($event$$282_panelWindowId$$4$$);
  $frameDom$$6_title$$17$$ || ($frameDom$$6_title$$17$$ = $event$$282_panelWindowId$$4$$.currentTarget);
  $AdfAssert$$.$assertDomElement$($frameDom$$6_title$$17$$, "IFRAME");
  $event$$282_panelWindowId$$4$$ = $frameDom$$6_title$$17$$.getAttribute($AdfDhtmlRichDialogService$$.$_PANELWINDOWID_EXPANDO$);
  $AdfAssert$$.$assertString$($event$$282_panelWindowId$$4$$);
  $page$$197_panelWindow$$4$$ = $page$$197_panelWindow$$4$$.$findComponent$($event$$282_panelWindowId$$4$$);
  $AdfAssert$$.$assertPrototype$($page$$197_panelWindow$$4$$, AdfRichPanelWindow);
  ($frameDom$$6_title$$17$$ = $frameDom$$6_title$$17$$.contentWindow.document.title) && $page$$197_panelWindow$$4$$.setTitle($frameDom$$6_title$$17$$);
};
$AdfDhtmlRichDialogService$$.$_checkForIframeTitleChangeWithPPRNavOn$ = function $$AdfDhtmlRichDialogService$$$$_checkForIframeTitleChangeWithPPRNavOn$$($rtnId$$21$$) {
  $AdfAssert$$.$assertNumeric$($rtnId$$21$$);
  var $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$ = $AdfDhtmlRichDialogService$$.$_getDialogStateToken$($rtnId$$21$$);
  if ($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$) {
    var $page$$198$$ = $AdfPage$$.$PAGE$, $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$ = $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$.popupId;
    $AdfAssert$$.$assertString$($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$);
    if ($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$ = $page$$198$$.$findComponent$($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$)) {
      $AdfAssert$$.$assertPrototype$($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$, AdfRichPopup);
      var $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$ = $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$.$getPeer$();
      $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$.bind($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$);
      $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$ = $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$.$getDomElement$().getAttribute($AdfDhtmlRichDialogService$$.$_INLINEFRAMEID_EXPANDO$);
      $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$ = $AdfPage$$.$PAGE$.$findComponent$($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$);
      $AdfAssert$$.$assertPrototype$($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$, AdfRichInlineFrame);
      $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$ = $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$.$getPeer$();
      $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$.bind($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$);
      $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$ = $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$.$__getIframe$();
      $AdfAssert$$.$assertDomElement$($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$, "IFRAME");
      $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$ = $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$.getAttribute($AdfDhtmlRichDialogService$$.$_PANELWINDOWID_EXPANDO$);
      $AdfAssert$$.$assertString$($inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$);
      $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$ = $page$$198$$.$findComponent$($inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$);
      $AdfAssert$$.$assertPrototype$($inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$, AdfRichPanelWindow);
      ($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$ = $frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$.contentWindow.document.title) && $inlineFramePeer$$4_panelWindow$$5_panelWindowId$$5_popupPeer$$8$$.setTitle($frameDom$$7_inlineFrame$$84_inlineFrameId$$4_popup$$47_popupId$$71_state$$85_title$$18$$);
      $page$$198$$.$scheduleTimer$($page$$198$$, $AdfDhtmlRichDialogService$$.$_checkForIframeTitleChangeWithPPRNavOn$, $rtnId$$21$$, 3E3);
    }
  }
};
$AdfDhtmlRichDialogService$$.$_notifyWindowClosed$ = function $$AdfDhtmlRichDialogService$$$$_notifyWindowClosed$$($returnId$$3$$, $withNextRequest$$) {
  var $page$$199$$ = $AdfPage$$.$PAGE$;
  $withNextRequest$$ ? $page$$199$$.$__notifyWindowClose$($returnId$$3$$) : $page$$199$$.$__notifyWindowCloseImmediately$(!0, $returnId$$3$$);
};
$AdfDhtmlRichDialogService$$.$_WINDOW_MODALITY_TYPE_APPLICATION_MODAL$ = "applicationModal";
$AdfDhtmlRichDialogService$$.$_WINDOW_DEFAULT_FEATURES_MAP$ = {alwayslowered:1, alwaysraised:1, channelmode:0, copyhistory:0, dependent:1, directories:0, fullscreen:0, hotkeys:1, location:0, menubar:0, resizable:1, scrollbars:1, status:1, titlebar:1, toolbar:1, "z-lock":1};
